/*
 *    VisNow
 *    Copyright (C) 2006-2019 University of Warsaw, ICM
 *    Copyright (C) 2020 onward visnow.org
 *    All rights reserved. 
 * 
 *  DO NOT ALTER OR REMOVE COPYRIGHT NOTICES OR THIS FILE HEADER.
 *
 *  This code is free software; you can redistribute it and/or modify it
 *  under the terms of the GNU General Public License version 3, 
 *  or (at your option) any later version, as published by the Free Software Foundation.  
 *  The authors designate this particular file as subject to the "Classpath" exception 
 *  as provided in the LICENSE file that accompanied this code.
 *
 *  This code is distributed in the hope that it will be useful, but WITHOUT
 *  ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
 *  FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
 *  version 3 for more details (a copy is included in the LICENSE file that
 *  accompanied this code).
 *
 *  You should have received a copy of the GNU General Public License version 3
 *  along with this work; if not, see http://www.gnu.org/licenses/gpl-3.0.txt 
 *
 *  Please contact visnow.org or visit www.visnow.org if you need additional information or
 *  have any questions.
 *
 */

package org.visnow.vn.system.framework;

import java.awt.Color;
import java.awt.Component;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.AdjustmentEvent;
import java.awt.event.AdjustmentListener;
import java.beans.PropertyVetoException;
import java.util.EventListener;
import java.util.EventObject;
import java.util.HashMap;
import java.util.Map;
import javax.swing.BorderFactory;
import javax.swing.Icon;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JMenuItem;
import javax.swing.JPopupMenu;
import javax.swing.JTable;
import static javax.swing.SwingConstants.LEFT;
import javax.swing.SwingUtilities;
import javax.swing.event.ListSelectionEvent;
import javax.swing.event.ListSelectionListener;
import javax.swing.table.DefaultTableCellRenderer;
import javax.swing.table.DefaultTableModel;
import javax.swing.table.TableCellRenderer;
import org.apache.log4j.Logger;
import org.visnow.vn.system.framework.UserMessageRow.ColumnName;
import org.visnow.vn.system.swing.UIIconLoader;
import org.visnow.vn.system.swing.UIManagerKey;
import org.visnow.vn.system.utils.usermessage.Level;
import org.visnow.vn.system.utils.usermessage.UserMessage;
import org.visnow.vn.system.utils.usermessage.UserMessageListener;

/**
 * Panel dedicated to show table of {@link UserMessage}(s).
 * It's tuned up to support expanding / collapsing of messages, autoscroll, customized view (icons, fonts, paddings, etc). Implements UserMessageListener, so
 * it's
 * auto updated with currently arriving message.
 *
 * @author szpak
 */
public class UserMessagePanel extends javax.swing.JPanel implements UserMessageListener
{
    public static final int OUTPUT = 0;
    public static final int INFO = 1;
    private static final Logger LOGGER = Logger.getLogger(UserMessagePanel.class);
    //set to true if scroll goes to bottom, stays true if was true and scroll position hasn't changed
    //set to false if scrolled up by user (or position has changed in some other way)
    private boolean isAutoScrollToBottom = true;
    private int lastScrollPosition = 0;
    //widely used user table model
    DefaultTableModel tableModel;

    public UserMessagePanel()
    {
        initComponents();
        postInitComponents();
    }

    /**
     * This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {
        java.awt.GridBagConstraints gridBagConstraints;

        jLayeredPane1 = new javax.swing.JLayeredPane();
        iconifyButton = new javax.swing.JButton();
        userMessagesTabbedPane = new javax.swing.JTabbedPane();
        userMessagesSP = new javax.swing.JScrollPane();
        userMessageTable = new javax.swing.JTable();
        userInfoMessageSP = new javax.swing.JScrollPane();
        customSizePanel1 = new org.visnow.vn.system.swing.CustomSizePanel();
        userInfoMessageLabel = new javax.swing.JLabel();

        addComponentListener(new java.awt.event.ComponentAdapter() {
            public void componentShown(java.awt.event.ComponentEvent evt) {
                formComponentShown(evt);
            }
        });
        setLayout(new java.awt.GridBagLayout());

        jLayeredPane1.setLayout(new java.awt.GridBagLayout());

        iconifyButton.setBackground(new java.awt.Color(153, 153, 153));
        iconifyButton.setBorderPainted(false);
        iconifyButton.setCursor(new java.awt.Cursor(java.awt.Cursor.DEFAULT_CURSOR));
        iconifyButton.setFocusPainted(false);
        iconifyButton.setMaximumSize(new java.awt.Dimension(18, 22));
        iconifyButton.setMinimumSize(new java.awt.Dimension(18, 22));
        iconifyButton.setOpaque(false);
        iconifyButton.setPreferredSize(new java.awt.Dimension(18, 22));
        iconifyButton.setVerticalAlignment(javax.swing.SwingConstants.TOP);
        iconifyButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                iconifyButtonActionPerformed(evt);
            }
        });
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 0;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.FIRST_LINE_END;
        gridBagConstraints.insets = new java.awt.Insets(0, 0, 0, 4);
        jLayeredPane1.add(iconifyButton, gridBagConstraints);

        userMessagesTabbedPane.setInheritsPopupMenu(true);

        userMessagesSP.setAutoscrolls(true);
        userMessagesSP.setInheritsPopupMenu(true);
        userMessagesSP.setPreferredSize(new java.awt.Dimension(3, 200));
        userMessagesSP.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mouseClicked(java.awt.event.MouseEvent evt) {
                userMessagesSPMouseClicked(evt);
            }
        });

        userMessageTable.setForeground(new java.awt.Color(102, 102, 102));
        userMessageTable.setModel(new javax.swing.table.DefaultTableModel(
            new Object [][] {

            },
            new String [] {
                "", "Application", "Source", "Message", "Timestamp"
            }
        ) {
            boolean[] canEdit = new boolean [] {
                false, false, false, false, false
            };

            public boolean isCellEditable(int rowIndex, int columnIndex) {
                return canEdit [columnIndex];
            }
        });
        userMessageTable.setAutoResizeMode(javax.swing.JTable.AUTO_RESIZE_ALL_COLUMNS);
        userMessageTable.setGridColor(new java.awt.Color(231, 231, 231));
        userMessageTable.setInheritsPopupMenu(true);
        userMessageTable.setSelectionMode(javax.swing.ListSelectionModel.SINGLE_SELECTION);
        userMessageTable.setShowHorizontalLines(false);
        userMessageTable.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mouseClicked(java.awt.event.MouseEvent evt) {
                userMessageTableMouseClicked(evt);
            }
        });
        userMessagesSP.setViewportView(userMessageTable);

        userMessagesTabbedPane.addTab("Output", userMessagesSP);

        userInfoMessageSP.setHorizontalScrollBarPolicy(javax.swing.ScrollPaneConstants.HORIZONTAL_SCROLLBAR_NEVER);
        userInfoMessageSP.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mouseClicked(java.awt.event.MouseEvent evt) {
                userInfoMessageSPMouseClicked(evt);
            }
        });

        customSizePanel1.setLayout(new java.awt.GridBagLayout());

        userInfoMessageLabel.setVerticalAlignment(javax.swing.SwingConstants.TOP);
        userInfoMessageLabel.setBorder(javax.swing.BorderFactory.createEmptyBorder(8, 8, 8, 8));
        userInfoMessageLabel.setVerticalTextPosition(javax.swing.SwingConstants.TOP);
        userInfoMessageLabel.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mouseClicked(java.awt.event.MouseEvent evt) {
                userInfoMessageLabelMouseClicked(evt);
            }
        });
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints.weightx = 1.0;
        gridBagConstraints.weighty = 1.0;
        customSizePanel1.add(userInfoMessageLabel, gridBagConstraints);

        userInfoMessageSP.setViewportView(customSizePanel1);

        userMessagesTabbedPane.addTab("Info", userInfoMessageSP);

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 0;
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.NORTHWEST;
        gridBagConstraints.weightx = 1.0;
        gridBagConstraints.weighty = 1.0;
        gridBagConstraints.insets = new java.awt.Insets(2, 0, 0, 0);
        jLayeredPane1.add(userMessagesTabbedPane, gridBagConstraints);

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints.weightx = 1.0;
        gridBagConstraints.weighty = 1.0;
        add(jLayeredPane1, gridBagConstraints);
    }// </editor-fold>//GEN-END:initComponents

    /**
     * Scrolls message table to bottom; This is done by SwingUtils.invokeLater.
     */
    private void scrollToBottom()
    {
        SwingUtilities.invokeLater(new Runnable()
        {
            @Override
            public void run()
            {
                //scroll to bottom
                userMessagesSP.getVerticalScrollBar().setValue(userMessagesSP.getVerticalScrollBar().getMaximum() - userMessagesSP.getVerticalScrollBar().getVisibleAmount());
            }
        });
    }

    /**
     * Tests if message table is scrolled to bottom
     */
    private boolean isAtBottom()
    {
        return userMessagesSP.getVerticalScrollBar().getValue() == userMessagesSP.getVerticalScrollBar().getMaximum() - userMessagesSP.getVerticalScrollBar().getVisibleAmount();
    }

    private void formComponentShown(java.awt.event.ComponentEvent evt) {//GEN-FIRST:event_formComponentShown
        //expand last message
        if (tableModel.getRowCount() > 0)
            messageToggle(tableModel.getRowCount() - 1, true);

        //and later scroll to bottom
        scrollToBottom();
    }//GEN-LAST:event_formComponentShown

    private void iconifyButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_iconifyButtonActionPerformed
        closeActionPerformed(evt);
    }//GEN-LAST:event_iconifyButtonActionPerformed

    private void userMessageTableMouseClicked(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_userMessageTableMouseClicked
        if(SwingUtilities.isRightMouseButton(evt)){
            if(!popup.getComponent(0).isEnabled()){
                popup.getComponent(0).setEnabled(true);
            }
            popup.show(userMessageTable, evt.getX(), evt.getY());
        }
    }//GEN-LAST:event_userMessageTableMouseClicked

    private void userMessagesSPMouseClicked(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_userMessagesSPMouseClicked
        if(SwingUtilities.isRightMouseButton(evt)){
            if(!popup.getComponent(0).isEnabled()){
                popup.getComponent(0).setEnabled(true);
            }
            popup.show(userMessagesSP, evt.getX(), evt.getY());
        }
    }//GEN-LAST:event_userMessagesSPMouseClicked

    private void userInfoMessageLabelMouseClicked(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_userInfoMessageLabelMouseClicked
        if(SwingUtilities.isRightMouseButton(evt)){
            if(popup.getComponent(0).isEnabled()){
                popup.getComponent(0).setEnabled(false);
            }
            popup.show(userInfoMessageLabel, evt.getX(), evt.getY());
        }
    }//GEN-LAST:event_userInfoMessageLabelMouseClicked

    private void userInfoMessageSPMouseClicked(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_userInfoMessageSPMouseClicked
        if(SwingUtilities.isRightMouseButton(evt)){
            if(popup.getComponent(0).isEnabled()){
                popup.getComponent(0).setEnabled(false);
            }
            popup.show(userInfoMessageSP, evt.getX(), evt.getY());
        }
    }//GEN-LAST:event_userInfoMessageSPMouseClicked

    /**
     * Notifies closeListener (if exists) about close action.
     *
     * @param evt
     */
    
    private void closeActionPerformed(java.awt.event.ActionEvent evt){
        if (closeListener != null)
        closeListener.closeButtonAction(new EventObject(evt.getSource()));
    }
    
    private void clearActionPerformed(java.awt.event.ActionEvent evt)
    {
         //to avoid firing selection event
        userMessageTable.clearSelection();
        //clear table
        DefaultTableModel tm = ((DefaultTableModel) userMessageTable.getModel());
        int size = tm.getRowCount();
        for (int i = size - 1; i >= 0; i--)
        tm.removeRow(i);
    }
    
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private org.visnow.vn.system.swing.CustomSizePanel customSizePanel1;
    private javax.swing.JButton iconifyButton;
    private javax.swing.JLayeredPane jLayeredPane1;
    private javax.swing.JLabel userInfoMessageLabel;
    private javax.swing.JScrollPane userInfoMessageSP;
    private javax.swing.JTable userMessageTable;
    private javax.swing.JScrollPane userMessagesSP;
    private javax.swing.JTabbedPane userMessagesTabbedPane;
    // End of variables declaration//GEN-END:variables
    private javax.swing.JPopupMenu popup;
    /**
     * Additional initialization of components that can't be made from NetBeans GUI including:
     * set custom table cell / header renderer, customize table / header view, add selection (onclick) handler for expand/collapse, add autoscroll functionality
     */
    private void postInitComponents()
    {

        tableModel = (DefaultTableModel) userMessageTable.getModel();

        //on click / selection listener - it's responsible for expanding/collapsing
        userMessageTable.getSelectionModel().addListSelectionListener(new ListSelectionListener()
        {
            @Override
            public void valueChanged(ListSelectionEvent e)
            {
                //works only when user clicks/selects row (doesn't work when user unselect row)
                //only single selection is allowed
                if (!e.getValueIsAdjusting() && userMessageTable.getSelectedRowCount() == 1)
                    messageToggle(userMessageTable.getSelectedRow());
            }
        });

        //table cell renderer
        userMessageTable.setDefaultRenderer(Object.class, new DefaultTableCellRenderer()
        {
            @Override
            public Component getTableCellRendererComponent(JTable table, Object value, boolean isSelected, boolean hasFocus, int row, int column)
            {
                UserMessageRow rowObject = (UserMessageRow) value;
                String stringValue = "";
                switch (UserMessageRow.getColumnName(column)) {
                    case LEVEL:
                        stringValue = rowObject.getLevel().name();
                        break;
                    case APPLICATION:
                        stringValue = rowObject.getApplicationName();
                        break;
                    case SOURCE:
                        stringValue = rowObject.getSourceName();
                        break;
                    case DESCRIPTION:
                        stringValue = rowObject.getDescription(rowObject.isExpanded(), true);
                        break;
                    case TIMESTAMP:
                        stringValue = rowObject.getTimestamp().toString().split("\\.")[0];    //without nano
                        break;
                }
                super.getTableCellRendererComponent(table, stringValue, isSelected, hasFocus, row, column);

                //TODO: preinit colors + create color for selected
                if (!isSelected)
                    setBackground(row % 2 == 0 ? new Color(0xf7f7f7) : new Color(0xeeeeee));
                //TODO: common padding
                //inner padding
                setBorder(BorderFactory.createEmptyBorder(4, 4, 4, 4));

                //alignment
                if (UserMessageRow.getColumnName(column) == ColumnName.LEVEL) { //center and set icon for Level column
                    setHorizontalAlignment(CENTER);
                    setText("");
                    Level level = rowObject.getLevel();
                    UIManagerKey iconKey = UIManagerKey.OptionPane_informationIcon;
                    if (level == Level.ERROR)
                        iconKey = UIManagerKey.OptionPane_errorIcon;
                    if (level == Level.WARNING)
                        iconKey = UIManagerKey.OptionPane_warningIcon;

                    //TODO: optimize get font size (move to postInitComponents)
                    int size = userMessageTable.getFontMetrics(userMessageTable.getFont()).getHeight();
                    setIcon(UIIconLoader.getIcon(iconKey, size, size));
                } else { //align to left and no icon for other columns
                    setIcon(null);
                    setHorizontalAlignment(LEFT);
                }
                setVerticalAlignment(TOP);

                //tool tip for message source, message content and application name
                switch (UserMessageRow.getColumnName(column)) {
                    case APPLICATION:
                    case SOURCE:
                        setToolTipText(value.toString());
                        break;
                    case DESCRIPTION:
                        setToolTipText(rowObject.getDescription(true, true));
                        break;
                    default:
                        setToolTipText(null); // or no tooltip
                }

                return this;
            }
        });

        //header renderer
        final TableCellRenderer headerRenderer = userMessageTable.getTableHeader().getDefaultRenderer();
        userMessageTable.getTableHeader().setDefaultRenderer(new TableCellRenderer()
        {
            @Override
            public Component getTableCellRendererComponent(JTable table, Object value, boolean isSelected, boolean hasFocus, int row, int column)
            {
                JLabel label = (JLabel) headerRenderer.getTableCellRendererComponent(table, value, isSelected, hasFocus, row, column);
                label.setBorder(BorderFactory.createCompoundBorder(label.getBorder(), BorderFactory.createEmptyBorder(0, 2, 0, 2)));
                label.setHorizontalAlignment(LEFT);

                return label;
            }
        });

        //TODO: refactor colors (common colors)
//        userMessageTable.getTableHeader()
//            .setBackground(new Color(0xDDDDDD));

        //TODO: set header color to same as table color or similar + refactor header border (remove bevel?)
        userMessageTable.getTableHeader()
            .setReorderingAllowed(false);
        //TODO: refactor to common font
        userMessageTable.getTableHeader().setFont(userMessageTable.getFont());

        //set column widths
        Map<UserMessageRow.ColumnName, Integer> columnMaxWidths = new HashMap<UserMessageRow.ColumnName, Integer>();
        columnMaxWidths.put(UserMessageRow.ColumnName.LEVEL, 50);
        columnMaxWidths.put(UserMessageRow.ColumnName.APPLICATION, 200);
        columnMaxWidths.put(UserMessageRow.ColumnName.SOURCE, 200);
        columnMaxWidths.put(UserMessageRow.ColumnName.DESCRIPTION, 1550);
        columnMaxWidths.put(UserMessageRow.ColumnName.TIMESTAMP, 450);

        for (Map.Entry<UserMessageRow.ColumnName, Integer> column : columnMaxWidths.entrySet())
            userMessageTable.getColumnModel().getColumn(UserMessageRow.getColumnIndex(column.getKey())).setMaxWidth(column.getValue());

        updateAllRowsHeight();

        //autoscroll to bottom
        userMessagesSP.getVerticalScrollBar().addAdjustmentListener(new AdjustmentListener()
        {
            @Override
            public void adjustmentValueChanged(AdjustmentEvent e)
            {
                int position = userMessagesSP.getVerticalScrollBar().getValue();

                //set to true if scroll goes to bottom, stays true if was true and scroll position hasn't changed
                //set to false if scrolled up by user (or position has changed in some other way)
                isAutoScrollToBottom = isAtBottom() || (isAutoScrollToBottom && position == lastScrollPosition);
                lastScrollPosition = position;
            }
        });
        
        
            JMenuItem closeItem = new JMenuItem("Close");
            JMenuItem clearItem = new JMenuItem("Clear");
            
            clearItem.addActionListener(new ActionListener() {

            @Override
            public void actionPerformed(ActionEvent e) {
                    clearActionPerformed(e);
                }
            });
            closeItem.addActionListener(new ActionListener() {

                @Override
                public void actionPerformed(ActionEvent e) {
                    closeActionPerformed(e);
                }
            });
            
            popup = new JPopupMenu();
            popup.add(clearItem);
            popup.add(closeItem);
            
            /**********iconifyableLabel***********/
            
            Icon icon = UIIconLoader.getIcon(UIManagerKey.InternalFrame_iconifyIcon);
            iconifyButton.setIcon(icon);
        
    }

    /**
     * Updates panel when new message arrives: adds this message (collapsed) to list , scrolls down if necessary.
     *
     * @param message
     */
    @Override
    public void newMessage(final UserMessage message)
    {
        //create new row based on new message
        final UserMessageRow row = new UserMessageRow(message);

        SwingUtilities.invokeLater(new Runnable()
        {
            @Override
            public void run()
            {
                if (message.getLevel()!=Level.HELP) {
                    
                    tableModel.addRow(row.toFakeRow());

                    //update last row height (it's better to manually specify index to have proper row updated)
                    updateRowHeights(tableModel.getRowCount() - 1);

                    if (isAutoScrollToBottom)
                        scrollToBottom();
                    
                    setActiveTab(OUTPUT);
                }else{
                    setInfoPanelText("<html>"+message.getDetails()+"</html>");
                    setActiveTab(INFO);
                }
            }   
        });
    }

    /**
     * Toggles expanded mode of message at
     * <code>selectedIndex</code>.
     *
     * @param selectedIndex message index to expand/collapse
     */
    private void messageToggle(int selectedIndex)
    {
        messageToggle(selectedIndex, !((UserMessageRow) tableModel.getValueAt(selectedIndex, 0)).isExpanded());
    }

    /**
     * Sets expanded or collapsed mode of message at
     * <code>selectedIndes</code>.
     *
     * @param selectedIndex message index to expand/collapse
     */
    private void messageToggle(int selectedIndex, boolean expanded)
    {
        ((UserMessageRow) tableModel.getValueAt(selectedIndex, 0)).setExpanded(expanded);
        tableModel.fireTableRowsUpdated(selectedIndex, selectedIndex);

        //clears selection
        userMessageTable.clearSelection();

        updateRowHeights(selectedIndex);

        if (isAutoScrollToBottom)
            scrollToBottom();

        //TODO: check the flow
    }

    /**
     * Updates height of all table rows to fit whole content.
     */
    private void updateAllRowsHeight()
    {
        updateRowHeights(-1);
    }

    /**
     * Updates height of selected table row or all table rows to fit whole content.
     *
     * @param selectedRow row to update or -1 to update all
     */
    private void updateRowHeights(int selectedRow)
    {
        //by default all rows to update
        int startRow = 0;
        int endRow = userMessageTable.getRowCount() - 1;

        if (selectedRow != -1)
            endRow = startRow = selectedRow;

        for (int row = startRow; row <= endRow; row++) {
            int rowHeight = userMessageTable.getRowHeight();

            for (int column = 0; column < userMessageTable.getColumnCount(); column++) {
                Component comp = userMessageTable.prepareRenderer(userMessageTable.getCellRenderer(row, column), row, column);
                rowHeight = Math.max(rowHeight, comp.getPreferredSize().height);
            }

            userMessageTable.setRowHeight(row, rowHeight);
        }
    }

    /**
     * Listens to close button action.
     */
    public interface CloseListener extends EventListener
    {

        public void closeButtonAction(EventObject event);
    }

    private CloseListener closeListener = null;

    /**
     * Sets close listener. Only one listeners is supported and {@link UnsupportedOperationException} is thrown if second listener is added.
     * <code>addCloseListener</code> is used to have full support of event bindings in Netbeans design mode.
     *
     * @param listener
     */
    public void addCloseListener(CloseListener listener)
    {
        if (closeListener != null)
            throw new UnsupportedOperationException("Only one close listener is allowed");
        closeListener = listener;
    }

    public void removeCloseListener(CloseListener listener)
    {
        closeListener = null;
    }

    public int getActiveTabID() {
        return userMessagesTabbedPane.getSelectedIndex();
    }
    
    public void setActiveTab(int idx){
        if (idx>-1&&idx<userMessagesTabbedPane.getTabCount()) {
            userMessagesTabbedPane.setSelectedIndex(idx);
        }
    }
    
    public void setInfoPanelText(String text)
    {
        userInfoMessageLabel.setText(text);
    }
    
    /**
     * Test frame
     *
     * @param args
     */
    public static void main(String[] args)
    {

        SwingUtilities.invokeLater(new Runnable()
        {
            @Override
            public void run()
            {
                JFrame f = new JFrame();
                f.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
                UserMessagePanel messagePanel = new UserMessagePanel();
                f.add(messagePanel);
                f.pack();
                f.setVisible(true);

                messagePanel.newMessage(new UserMessage("App 1", "image reader", "Image successfully loaded", "grapefruit.png <br> RGB, width: 100 weight: 200 <br> PNG 8 bit", Level.INFO));
                messagePanel.newMessage(new UserMessage("App 1", "DICOM reader", "cannot reconstruct volume due to sorting error!", "2 + 2 <> 4", Level.ERROR));
                messagePanel.newMessage(new UserMessage("Application 3", "image reader", "Image successfully loaded", "lena.jpg <br> RGB, width: 256 weight: 256 <br> JPEG", Level.INFO));
            }
        });
    }
}
